std::shared_future< _Res > Class Template Reference
Concurrency » Futures

`#include <future>`

Inheritance diagram for std::shared_future< _Res >:
[legend]

## Public Member Functions

| shared_future (const shared_future &__sf) noexcept
| shared_future (future< _Res > &&__uf) noexcept
| shared_future (shared_future &&__sf) noexcept
const _Res & | get () const
shared_future & | operator= (const shared_future &__sf) noexcept
shared_future & | operator= (shared_future &&__sf) noexcept
bool | valid () const noexcept
void | wait () const
template<typename _Rep, typename _Period>
future_status | wait_for (const chrono::duration< _Rep, _Period > &__rel) const
template<typename _Clock, typename _Duration>
future_status | wait_until (const chrono::time_point< _Clock, _Duration > &__abs) const

## Protected Types

typedef __future_base::_Result< _Res > & | __result_type
typedef shared_ptr< _State_base > | __state_type

## Protected Member Functions

__result_type | _M_get_result () const
void | _M_swap (__basic_future &__that) noexcept

## Detailed Description

template<typename _Res>
class std::shared_future< _Res >

Primary template for shared_future.

Definition at line 931 of file future.

## Member Typedef Documentation

## __result_type

template<typename _Res>

typedef __future_base::_Result<_Res>& std::__basic_future< _Res >::__result_type

protected inherited

Definition at line 708 of file future.

## __state_type

template<typename _Res>

typedef shared_ptr<_State_base> std::__basic_future< _Res >::__state_type

protected inherited

Definition at line 707 of file future.

## Constructor & Destructor Documentation

## shared_future() [1/4]

template<typename _Res>

std::shared_future< _Res >::shared_future | ( |  | ) |

inline constexpr noexcept

Definition at line 943 of file future.

## shared_future() [2/4]

template<typename _Res>

std::shared_future< _Res >::shared_future | ( | const shared_future< _Res > & | __sf | ) |

inline noexcept

Copy constructor.

Definition at line 946 of file future.

## shared_future() [3/4]

template<typename _Res>

std::shared_future< _Res >::shared_future | ( | future< _Res > && | __uf | ) |

inline noexcept

Construct from a future rvalue.

Definition at line 949 of file future.

References std::move().

## shared_future() [4/4]

template<typename _Res>

std::shared_future< _Res >::shared_future | ( | shared_future< _Res > && | __sf | ) |

inline noexcept

Construct from a shared_future rvalue.

Definition at line 954 of file future.

References std::move().

## Member Function Documentation

## _M_get_result()

template<typename _Res>

__result_type std::__basic_future< _Res >::_M_get_result | ( |  | ) | const

inline protected inherited

Wait for the state to be ready and rethrow any stored exception.

Definition at line 747 of file future.

Referenced by std::future< _Res >::get(), and std::shared_future< _Res >::get().

## _M_swap()

template<typename _Res>

void std::__basic_future< _Res >::_M_swap | ( | __basic_future< _Res > & | __that | ) |

inline protected noexcept inherited

Definition at line 756 of file future.

## get()

template<typename _Res>

const _Res & std::shared_future< _Res >::get | ( |  | ) | const

inline

Retrieving the value.

Definition at line 972 of file future.

References std::__basic_future< _Res >::_M_get_result().

## operator=() [1/2]

template<typename _Res>

shared_future & std::shared_future< _Res >::operator= | ( | const shared_future< _Res > & | __sf | ) |

inline noexcept

Definition at line 958 of file future.

## operator=() [2/2]

template<typename _Res>

shared_future & std::shared_future< _Res >::operator= | ( | shared_future< _Res > && | __sf | ) |

inline noexcept

Definition at line 964 of file future.

## valid()

template<typename _Res>

bool std::__basic_future< _Res >::valid | ( |  | ) | const

inline noexcept inherited

Definition at line 719 of file future.

## wait()

template<typename _Res>

void std::__basic_future< _Res >::wait | ( |  | ) | const

inline inherited

Definition at line 722 of file future.

## wait_for()

template<typename _Res>
template<typename _Rep, typename _Period>

future_status std::__basic_future< _Res >::wait_for | ( | const chrono::duration< _Rep, _Period > & | __rel | ) | const

inline inherited

Definition at line 730 of file future.

## wait_until()

template<typename _Res>
template<typename _Clock, typename _Duration>

future_status std::__basic_future< _Res >::wait_until | ( | const chrono::time_point< _Clock, _Duration > & | __abs | ) | const

inline inherited

Definition at line 738 of file future.

The documentation for this class was generated from the following file:

- future